=== debian/changelog ===
libzstd (1.4.10+dfsg-1+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 1.4.8+dfsg-2.1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Fri, 07 May 2021 07:36:26 +0000]
  * Fix broken unaligned accesses.

 -- Raspbian forward porter <root@raspbian.org>  Fri, 08 Apr 2022 05:08:44 +0000

libzstd (1.4.10+dfsg-1) unstable; urgency=medium

  * Point the Vcs-* fields to the pkg-rpm-team repository.
  * New upstream release (Closes: #1008078):
    - remove the years from the main upstream copyright notice
    - refresh patch line numbers

 -- Peter Pentchev <roam@debian.org>  Sat, 02 Apr 2022 22:44:53 +0300

libzstd (1.4.9+dfsg-1) unstable; urgency=medium

  * New maintainer, bring libzstd under the RPM packaging team's umbrella.
    Many thanks to the Debian Med Team and everyone else for their work!
  * Add my debian/* copyright notice.
  * Catch up with a renamed Lintian tag in an override.
  * Correct the upstream copyright years.
  * Add a trivial git-buildpackage config file.
  * New upstream release:
    - update the upstream copyright years
    - adapt the 0008-Address-embedded-zlib patch
    - refresh patch line numbers
  * Fix a kFreeBSD FTBFS - UTIME_NOW is not defined.

 -- Peter Pentchev <roam@debian.org>  Sun, 20 Mar 2022 18:25:50 +0200
