=== debian/control ===
Source: libzstd
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders: Peter Pentchev <roam@debian.org>
Section: libs
Priority: optional
Build-Depends: d-shlibs,
               debhelper-compat (= 13),
               help2man,
               liblz4-dev,
               liblzma-dev,
               zlib1g-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/libzstd
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/libzstd.git
Homepage: https://github.com/facebook/zstd
Rules-Requires-Root: binary-targets

Package: libzstd-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libzstd1 (= ${binary:Version}),
         ${misc:Depends}
Description: fast lossless compression algorithm -- development files
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the headers and static library.

Package: libzstd1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast lossless compression algorithm
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the shared library.

Package: zstd
Architecture: any
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast lossless compression algorithm -- CLI tool
 Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
 real-time compression scenarios at zlib-level compression ratio.
 .
 This package contains the CLI program implementing zstd.

Package: libzstd1-udeb
Architecture: any
Section: debian-installer
Depends: ${misc:Depends},
         ${shlibs:Depends}
Package-Type: udeb
Description: fast lossless compression algorithm library for debian-installer
